#include <stdio.h>
#include <qdir.h>
#include <kapp.h>
#include <klocale.h>
#include "dlgfractype.h"
//#include "dlgfractype.moc"

FracTypeDlg::FracTypeDlg(QWidget* parent, const char* name):
     QDialog (parent, name, TRUE)
{
int Lauf;
//fprintf(stdout,"FracTypeDlg::FracTypeDlg\n");

   setCaption(i18n("Select Fractal-Type"));
   setFixedSize(300,350);

   // Listbox
   FracList = new QListBox(this, "FracList");
   FracList->setGeometry(50,25,200,265);
   for (Lauf=0; Lauf<FracTypeCount; Lauf++)   // Liste fllen
      FracList->insertItem(FracNames[Lauf]);
   connect(FracList, SIGNAL(selected(int)), this, SLOT(accept()) );

   // OK-Button
   QPushButton *OkBtn = new QPushButton(i18n("OK"), this, "OkBtn");
   OkBtn->setGeometry(25,310,80,30);
   OkBtn->setDefault(TRUE);
   connect(OkBtn, SIGNAL(clicked()), SLOT(accept()) );

   // cancel-Button
   QPushButton *AbortBtn = new QPushButton(i18n("Cancel"), this, "OkBtn");
   AbortBtn->setGeometry(195,310,80,30);
   connect(AbortBtn, SIGNAL(clicked()), SLOT(reject()) );

   FracList->setFocus();
}

void FracTypeDlg::SetFracType(int Type) {
   FracList->setCurrentItem(Type);
}

int FracTypeDlg::GetFracType() {
   return FracList->currentItem();
}
