#ifndef MAND4B_H
#define MAND4B_H
#include <complex.h>
#include <qwidget.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qdialog.h>
#include <qlined.h>
#include <qchkbox.h>
#include "basefrac.h"

class Mand4b : public BaseFract
{
public:
   virtual void Init(int SizeX, int SizeY);
   virtual void SetDefaultCorners(double *x1, double *x2, double *y1, double *y2);
   virtual double SetDefaultParams(int);
   virtual int CalcPoint(int x, int y);
   virtual const int GetFracType() { return FT_MAND4B; }
   virtual const char* GetFracName(void) { return "Mand4b"; }
   virtual const char* GetFracInfo(void);    // Informationen ber dieses Fraktal
   virtual int SetupFrac(BaseFract* Frac); // type specific-setup
private:
};
#endif
