#include <iostream.h>
//#include <math.h>
#include <complex.h>

#define MaxIter 100

struct komplex {   // komplexe zahl
  double re,im;    // bestehend ais Real- und Imaginrteil
};

struct komplex cadd(struct komplex a, struct komplex b) {
// komplexe Addition
struct komplex h;
  h.re = a.re+b.re;
  h.im = a.im+b.im;
  return h;
}

struct komplex csub(struct komplex a, struct komplex b) {
// komplexe Subtraktion
struct komplex h;
  h.re = a.re-b.re;
  h.im = a.im-b.im;
  return h;
}

struct komplex cmul(struct komplex a, struct komplex b) {
// komplexe Multiplikation
struct komplex h;
  h.re = a.re*b.re - a.im*b.im;
  h.im = a.re*b.im + a.im*b.re;
  return h;
}

struct komplex cdiv(struct komplex a, struct komplex b) {
// komplexe Division
struct komplex h;
double nenner;
  nenner = b.re*b.re  + b.im*b.im;
  h.re   = (a.re*b.re + a.im*b.im) / nenner;
  h.im   = (a.im*b.re - a.re*b.im) / nenner;
  return h;
}




int ComplexCalc(double rx, double ry)
{
complex<double> Z,z,h,h1,P,R,P1;
int iter=0;

   cout << "(" << rx << "," << ry << ")\n";
   Z=complex<double>(rx,ry);
   P=complex<double>(4,0);
   R=complex<double>(1,0);
   P1=P-1.0;
   do {
      z=Z;
      h=pow(z,P1);
      cout << h;
      h=(P*h);
      cout << h << "  ";
      h1=(P1*pow(z,P)+R);
      //h1=3.0*z*z*z*z+R;
      // cout << z*z*z*z;
      cout << h1 << "  ";
      Z=h1/h;
      iter++;
      h=(Z-z);
      cout << Z << "\n";
   } while ( (iter<MaxIter) && ( fabs(norm(h))>0.000001));
   return iter;
}

int FloatCalc(double rx, double ry)
{
int iter=0,Lauf;
struct komplex h,h2,n,z,za;
int l[2]={4,0};
double par=l[0],par1=l[0]-1;

   cout << "(" << rx << "," << ry << ")\n";
   
   z.re=rx;  z.im=ry;
   do {
      za=z;
      // Berechnung z^(p-1)
      h=z;
      for (Lauf=2; Lauf<l[0]; Lauf++) {
         h=cmul(h,z);
         //h=n;
      }
      cout << "(" << h.re << "," << h.im << ")";
      //n=cmul(z,z);
      //h=cmul(n,z);
      n.re=(double)l[0]*h.re;
      n.im=(double)l[0]*h.im;
      cout << "(" << n.re << "," << n.im << ")  ";
      
      h2=cmul(h,z);
      //cout << "(" << h2.re << "," << h2.im << ")  ";
      
      h.re=(double)(l[0]-1)*h2.re+1.0;
      h.im=(double)(l[0]-1)*h2.im;
      cout << "(" << h.re << "," << h.im << ")  ";
      
      z=cdiv(h,n);
      
      h=csub(z,za);
      cout << "(" << z.re << "," << z.im << ")\n";
      iter++;
   } while ( (iter<MaxIter) && ( fabs(h.re*h.re+h.im*h.im)>0.000001));
   return iter;
}



void main(void) {
complex<double> Z;
int P=3;
int i;

  Z=complex<double>(3,0.5);
  
//  for (i=1; i<10; i++) {
//     Z=((P-1)*pow(Z,P)+1)/(P*pow(Z,(P-1)));
//     cout << Z << "\n";
//  }
   ComplexCalc(2,2.2);
   cout << "-----------------\n";
   FloatCalc(2,2.2);
}
